#!/bin/bash

###########################
# mp3-genre-group.sh v0.4 #
###########################
#
# This little thingy will change the group of the dir to that of the genre
# listed in the .message-file made by zipscript-c.
# Run in crontab or whatever.
# Meant to work with mp3-dirs, ofcourse.
# As always, my script comes with no guarantees.
#
# Yes, I know this script suffers from a "bad name", like the rest of my
# script. Who cares! ;)
#
# New in v0.4
# -----------
# Seems like I didn't get rid of that bug after all. Hopefully it's fixed
# now. Because if this, the script is substantially slower, and can take
# minutes to run if you have a lot of mp3-dirs/days. The next version will
# be substantially faster (I hope).
#
# New in v0.3
# -----------
# added support for non-standard ID3-tags
# fixed a small bug with groups
# now suppress errors if prior dated dirs does not exists
#
##########################################
# The config - change to the appropriate #
##########################################

# Your GLFTPD root-dir
glftpd_dir="/glftpd"

# Where do you keep your MP3's?
glftpd_mp3="/site/MP3"

# The name of your dated dir. Don't worry - it will work with non-dated dirs
# as well. (see example commented)
dated_format="%m%d"
#dated_format="ARCHIVE"

# Here's a list of days backward it will make changes... 3 days ago, 2 days ago,
# yesterday and today are the defaults. Check the date-command for more info.
daysback="3 2 1 0"
#daysback="0"

# Should the script create a .message file in the root of the dated dir, where it
# lists the name of all dirs, sorted by genre?
create_message="Y"
#create_message="N"

# These next two variables should be changes if you have changed the m3u settings
# in your zipscript-c, or use a different m3u extractor. In the .message-file in
# the mp3-dir, the name of the genre is normally prefixed by a word (Genre) and a
# delimeter (:). If the genre is Hip-Hip, you'll find something like this in the
# .message:
# |     Genre    : Hip-Hop
# These variables allow you to change the word and delimeter, so the script may
# recognize it, and be able to extract the genre. In norwegian, you could perhaps
# use the following:
# delimeter=">>"
# name_genre="Sjanger"
# |     Sjanger >> Hip-Hop
# If this make no meaning to you whatsoever, or you have not made any particular
# modifications to the m3u-extraction, leave the two variables as is.
delimeter=":"
name_genre="Genre"

#################
# End of Config #
#################

# no need to change below


grp_largest="100"
bsddays="d"
if [ `date -v 3d 2&>1 /dev/null; echo $?` -gt 0 ]; then
 os_type="linux"
else
 os_type="fbsd"
fi
for dayback in $daysback; do
 if [ "$os_type" = "linux" ]; then
  work_dir="$glftpd_dir""$glftpd_mp3""/""`date --date="$dayback days ago" +"$dated_format"`"
 else
  work_dir="$glftpd_dir""$glftpd_mp3""/""`date -v -$dayback$bsddays +"$dated_format"`"
 fi
 if [ -e $work_dir ]; then
  for dir in `ls -1F $work_dir`; do
   if [ -d $work_dir/$dir ]; then
    if [ -e $work_dir/$dir/.message ]; then
     genre="`cat $work_dir/$dir/.message | grep -iw "$name_genre" | awk -F "$delimeter" '{ print $2 }' | awk -F " " '{ print $1 }'`"
    echo "$genre : $dir" >> $work_dir/.message.temp
    else
     for subdir in `ls -1F $work_dir/$dir`; do
       if [ "`echo $subdir | grep "/"`" != "" ]; then
         if [ -e $work_dir/$dir/$subdir/.message ]; then
           genre="`cat $work_dir/$dir/$subdir/.message | grep -iw "$name_genre" | awk -F "$delimeter" '{ print $2 }' | awk -F " " '{ print $1 }'`"
           echo "$genre : $dir" >> $work_dir/.message.temp
         else
           nochange=1
         fi
       else
         nochange=1
       fi
     done
    fi
    if [ "`cat $glftpd_dir/etc/group | sed "s/ /_/g" | awk -F ":" '{ print $1 }' | grep $genre`" = "" ]; then
     for grp in `cat $glftpd_dir/etc/group | sed "s/ /_/g" | awk -F ":" '{ print $1 ":" $3 }'`; do
       grp_string=`echo "$grp" | awk -F ":" '{ print $2 }'`
       if [ ! $grp_string -lt $grp_largest ]; then
         grp_largest=$grp_string
       fi
     done
     grp=`expr $grp_largest \+ 100`
     echo "$genre:MP3:$grp:" >> $glftpd_dir/etc/group
     echo "$genre:MP3:$grp:" >> $glftpd_dir/etc/group-
     chgrp $grp $work_dir/$dir
    else
     grps="`cat $glftpd_dir/etc/group | sed "s/ /_/g" | awk -F ":" '{ print $1 ":" $3 }'`"
     for grp in $grps; do
      testit="`echo $grp | grep $genre`"
      if [ ! "$testit" = "" ]; then
       found="`echo $testit | awk -F ":" '{ print $2 }'`";
       break;
      fi
     done
    grp=$found
     chgrp $grp $work_dir/$dir
     nochange=1
    fi
   fi
  done
  if [ -e $work_dir/.message.temp ]; then
   if [ ! "$create_message" = "N" ]; then
    cat $work_dir/.message.temp | sort -n > $work_dir/.message
   fi
   rm $work_dir/.message.temp
  else
   nochange=1
  fi
 fi
done
